# include "stdio.h"
# define U(x) ((x)&0377)
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin ={stdin}, *yyout ={stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
static char *scan_l =
	"$Header: /data/01/postgres/src/backend/parser/RCS/scan.l,v 1.25 1993/01/16 03:14:59 aoki Exp $";
/**********************************************************************
  scan.l
  lexical scanner for POSTGRES 
 **********************************************************************/

#include <ctype.h>
#include <math.h>

#include "parse.h"
#include "nodes/pg_lisp.h"
#include "parser/atoms.h"


#undef input
#undef unput

extern LispValue yylval;
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{ scancmnt();		}
break;
case 2:
	{ return TYPECAST;	}
break;
case 3:
{
			char buf[8192];
			scanspecial(buf,sizeof(buf));
			yylval = lispString(buf);
			return (SCONST);
		}
break;
case 4:
	{ return (yytext[0]);	}
break;
case 5:
{
			yylval = lispString(yytext);
			return (Op);
		}
break;
case 6:
        {       yylval = lispInteger(atoi(&yytext[1]));		
	                return (PARAM);
                }
break;
case 7:
{
			yylval = lispInteger(atoi(yytext));		
			return (ICONST);
		}
break;
case 8:
	{
			yylval = lispFloat(atof(yytext));
			return (FCONST);
		}
break;
case 9:
{
			char buf[8192];
			scanstr(buf,sizeof(buf));
			yylval = lispString(buf);
			return (SCONST);
		}
break;
case 10:
{
			char buf[2];
			scanchar(buf);
			yylval = lispString(buf);
			return (CCONST);
		}
break;
case 11:
{
			ScanKeyword	*keyword;

			keyword = ScanKeywordLookup(yytext);
			if (keyword != NULL) {
				yylval = lispAtom(keyword->name);
				return (keyword->value);
			} else {
				yylval = (LispValue) lispName(yytext);
				return (IDENT);
			}
		}
break;
case 12:
	{ /* void */		}
break;
case 13:
	{ return (yytext[0]);	}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] ={
0,

13,
0,

12,
13,
0,

12,
0,

5,
13,
0,

9,
13,
0,

4,
13,
0,

10,
13,
0,

4,
13,
0,

4,
13,
0,

4,
13,
0,

7,
13,
0,

4,
13,
0,

11,
13,
0,

3,
5,
13,
0,

5,
0,

5,
0,

6,
0,

1,
5,
0,

7,
0,

2,
5,
0,

11,
0,

8,
0,

8,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] ={
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	1,7,	
0,0,	1,8,	0,0,	0,0,	
1,9,	1,10,	0,0,	1,11,	
1,11,	2,7,	0,0,	0,0,	
1,12,	1,13,	2,9,	0,0,	
11,18,	2,11,	11,18,	0,0,	
11,18,	11,18,	2,12,	1,14,	
0,0,	1,11,	1,11,	1,11,	
0,0,	0,0,	1,15,	0,0,	
0,0,	2,14,	1,15,	2,11,	
2,11,	2,11,	0,0,	6,17,	
0,0,	6,17,	6,18,	6,17,	
6,17,	0,0,	11,18,	11,18,	
6,18,	6,18,	0,0,	6,18,	
18,18,	6,18,	18,18,	25,26,	
18,18,	18,18,	0,0,	0,0,	
0,0,	1,16,	0,0,	0,0,	
6,18,	0,0,	6,18,	6,18,	
6,18,	6,17,	6,17,	2,16,	
0,0,	0,0,	0,0,	0,0,	
0,0,	11,18,	0,0,	11,18,	
0,0,	0,0,	18,18,	18,18,	
0,0,	0,0,	0,0,	25,26,	
0,0,	1,11,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2,11,	
6,17,	0,0,	6,17,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	11,18,	0,0,	0,0,	
0,0,	18,18,	0,0,	18,18,	
0,0,	0,0,	0,0,	8,18,	
0,0,	8,18,	8,18,	8,18,	
8,18,	0,0,	0,0,	0,0,	
8,18,	8,18,	6,18,	8,18,	
6,17,	8,18,	8,19,	8,19,	
8,19,	8,19,	8,19,	8,19,	
8,19,	8,19,	8,19,	8,19,	
8,18,	18,18,	8,18,	8,18,	
8,18,	8,18,	8,18,	0,0,	
0,0,	12,18,	0,0,	12,18,	
0,0,	12,18,	12,18,	0,0,	
0,0,	13,21,	12,20,	13,22,	
13,22,	13,22,	13,22,	13,22,	
13,22,	13,22,	13,22,	13,22,	
13,22,	14,18,	0,0,	14,18,	
0,0,	14,18,	14,18,	0,0,	
8,18,	0,0,	8,18,	12,18,	
12,18,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	19,19,	
19,19,	19,19,	19,19,	0,0,	
0,0,	0,0,	14,23,	0,0,	
0,0,	0,0,	0,0,	14,18,	
14,18,	0,0,	0,0,	0,0,	
0,0,	0,0,	8,18,	0,0,	
8,18,	0,0,	12,18,	0,0,	
12,18,	21,25,	21,25,	21,25,	
21,25,	21,25,	21,25,	21,25,	
21,25,	21,25,	21,25,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	20,18,	14,18,	20,18,	
14,18,	20,18,	20,18,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	12,18,	0,0,	
0,0,	0,0,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
0,0,	0,0,	0,0,	20,18,	
20,18,	0,0,	14,18,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	0,0,	20,18,	0,0,	
20,18,	15,24,	0,0,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	15,24,	15,24,	15,24,	
15,24,	23,18,	20,18,	23,18,	
0,0,	23,18,	23,18,	26,27,	
0,0,	26,27,	0,0,	0,0,	
26,28,	26,28,	26,28,	26,28,	
26,28,	26,28,	26,28,	26,28,	
26,28,	26,28,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	23,18,	
23,18,	27,28,	27,28,	27,28,	
27,28,	27,28,	27,28,	27,28,	
27,28,	27,28,	27,28,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	23,18,	0,0,	
23,18,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	23,18,	0,0,	
0,0};
struct yysvf yysvec[] ={
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-11,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+42,	0,		yyvstop+8,
yycrank+0,	0,		yyvstop+11,
yycrank+122,	0,		yyvstop+14,
yycrank+0,	0,		yyvstop+17,
yycrank+0,	0,		yyvstop+20,
yycrank+19,	yysvec+6,	yyvstop+23,
yycrank+156,	yysvec+6,	yyvstop+26,
yycrank+151,	0,		yyvstop+29,
yycrank+176,	yysvec+6,	yyvstop+32,
yycrank+238,	0,		yyvstop+35,
yycrank+0,	yysvec+6,	yyvstop+38,
yycrank+0,	yysvec+6,	yyvstop+42,
yycrank+55,	yysvec+6,	yyvstop+44,
yycrank+173,	0,		yyvstop+46,
yycrank+236,	yysvec+6,	yyvstop+48,
yycrank+205,	0,		0,	
yycrank+0,	yysvec+13,	yyvstop+51,
yycrank+328,	yysvec+6,	yyvstop+53,
yycrank+0,	yysvec+15,	yyvstop+56,
yycrank+22,	yysvec+21,	yyvstop+58,
yycrank+324,	0,		0,	
yycrank+345,	0,		0,	
yycrank+0,	yysvec+27,	yyvstop+60,
0,	0,	0};
struct yywork *yytop = yycrank+454;
struct yysvf *yybgin = yysvec+1;
char yymatch[] ={
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,011 ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,'!' ,01  ,'!' ,'$' ,'!' ,'!' ,01  ,
'(' ,'(' ,'$' ,'+' ,'(' ,'+' ,'(' ,'$' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,'$' ,'(' ,'$' ,'$' ,'$' ,'!' ,
'!' ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'(' ,01  ,'(' ,'!' ,'A' ,
'!' ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,'$' ,01  ,'!' ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] ={
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	ncform	4.1	83/08/11	*/

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank){		/* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"unsigned char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
