/* NAME
 *	pg_schema.h
 *
 * DESCRIPTION
 *	Main include file for pg_schema.
 *
 * SccsId = "@(#)pg_schema.h	5.2 8/5/93"
 */

#include <stdio.h>
#include <stddef.h>
#include "gdi_postgres.h"
#include "gdi_turbo.h"
#include "limits.h"
#include "errno.h"
#include "proto.h"

Proto	(dbStatus, pg_init,   (dbConn *dbconn));
Proto	(dbStatus, pg_class,   (dbConn *dbconn, char *class_name, FILE *fp));
Proto	(dbStatus, pg_procs,   (dbConn *dbconn, char *obj_name, FILE *fp));
Proto	(dbStatus, pg_indexes, (dbConn *dbconn, char *obj_name, FILE *fp));
Proto	(void,	print_header,	(FILE *fp, char *str));

/* from $POSTGRESHOME/src/backend/catalog/pg_opclass.h */

#define	INT2_OPS	421
#define	BOX_OPS		422
#define	FLOAT8_OPS	423
#define	INT24_OPS	424
#define INT42_OPS	425
#define	INT4_OPS	426
#define	OID_OPS		427
#define	FLOAT4_OPS	428
#define	CHAR_OPS	429
#define	CHAR16_OPS	430
#define	TEXT_OPS	431
#define	ABSTIME_OPS	432
#define	BIGBOX_OPS	433
#define	POLY_OPS	434
#define OIDINT4_OPS	435
#define OIDCHAR16_OPS	436
