set Name {Jim's Jget}
set Help {May work with Jim's query tool.}

proc Action { dir  } {
	global env
	if {[set jbox [lsearch [Attribute nameorder] jaquithfname]] == -1} {
		ErrorBox "No jaquithfname field."
		return
	}
	if {[set ji [.qr.$jbox.ls.l curselection]] == {}} {
		NoticeBox "Please select a jaquith file."
		return
	}
	if {[llength $ji] > 1} {
		NoticeBox "Please select a single file."
		return
	}
	if {[set diskfname [FDSaveFilename -title {Save Jaquith File}]] == {}
	    || [set jfname [.qr.$jbox.ls.l get $ji]] == {}} return

	if {[set jget [SearchPath jget]] == {}} {
		ErrorBox "The jget program is not in your PATH."
		return
	}

	Working
	eval jget -filter $jfname > $diskfname'
	Waiting
}
