
# line 2 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
/* ----------------------------------------------------------------
 *   FILE
 *	backendparse.y
 *
 *   DESCRIPTION
 *	yacc parser grammer for the "backend" initialization
 *	program.  uses backendscan.lex and backendsup.c support
 *	routines.
 *
 *   NOTES
 *
 * ----------------------------------------------------------------
 */
static	char ami_parser_y[] = 
 "$Header: /data/01/postgres/src/backend/bootstrap/RCS/bootparse.y,v 1.12 1992/12/19 01:38:45 aoki Exp $";

#include "access/heapam.h"
#include "bootstrap/bkint.h"
#include "tmp/portal.h" 
#include "storage/smgr.h" 
#include "nodes/pg_lisp.h"
#include "catalog/catname.h"

#undef BOOTSTRAP

#define TRUE 1
#define FALSE 0

#define DO_QUERY(query) { StartTransactionCommand();\
			  query;\
			  CommitTransactionCommand();\
			  if (!Quiet) { EMITPROMPT; }\
			}

#define DO_START { StartTransactionCommand();\
		 }

#define DO_END   { CommitTransactionCommand();\
		   if (!Quiet) { EMITPROMPT; }\
		   fflush(stdout); \
		 }

int num_tuples_read = 0;
extern int DebugMode;
extern int Quiet;
static OID objectid;

# define OPEN 257
# define XCLOSE 258
# define XCREATE 259
# define P_RELN 260
# define INSERT_TUPLE 261
# define QUIT 262
# define ID 263
# define STRING 264
# define FLOAT 265
# define INT 266
# define XDEFINE 267
# define MACRO 268
# define XDECLARE 269
# define INDEX 270
# define ON 271
# define USING 272
# define XBUILD 273
# define INDICES 274
# define COMMA 275
# define COLON 276
# define EQUALS 277
# define LPAREN 278
# define RPAREN 279
# define AS 280
# define XIN 281
# define XTO 282
# define XDESTROY 283
# define XRENAME 284
# define RELATION 285
# define ATTR 286
# define ADD 287
# define DISPLAY 288
# define OBJ_ID 289
# define SHOW 290
# define BOOTSTRAP 291
# define NULLVAL 292
# define low 293
# define high 294
#define yyclearin Int_yychar = -1
#define yyerrok Int_yyerrflag = 0
extern int Int_yychar;
extern short Int_yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE Int_yylval, Int_Int_yyval;
# define YYERRCODE 256

# line 376 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"



short Int_yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 62
# define YYLAST 166
short Int_yyact[]={

  17,  18,  20,  19,  22,  23,  39,  42,  44,  45,
  28,  91,  24, 107,  70,  48,  29, 106,  35,  68,
  79,  80,  67,  36,  61, 101,  21,  25,  60,  96,
  89,  30,  49,  31,  87,  35,  35,  79,  80, 103,
  36,  36,  97,  64,  63,  69,  62,  78,  55,  61,
  47,  34,  90,  66,  43,  35,  46,  52,  77,  50,
  36,  75,   3,  27,  78,  32,  26,  51, 104,  99,
  98,  74,  54,  41,  92,  33,  37,  73,  38,  40,
  16,  15,  14,  13,  12,  11,  10,   9,   8,   7,
   6,   5,   4,   2,   1,   0,  53,   0,   0,   0,
   0,  56,  57,  58,  59,   0,   0,   0,   0,   0,
   0,   0,   0,  65,   0,   0,   0,   0,   0,   0,
  72,   0,  76,   0,  81,  82,  83,  84,  85,  71,
   0,   0,  76,  86,   0,   0,  88,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,  76,  94,  95,
   0,  93,   0,   0,   0, 100,   0, 102,   0,   0,
   0, 105,   0,   0,   0, 108 };
short Int_yypact[]={

-257,-1000,-257,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-227,-208,-1000,
-285,-208,-282,-1000,-216,-277,-1000,-1000,-212,-224,
-253,-1000,-1000,-1000,-208,-1000,-1000,-1000,-208,-1000,
-1000,-1000,-229,-208,-208,-208,-208,-1000,-1000,-1000,
-251,-1000,-231,-234,-235,-208,-218,-258,-261,-232,
-266,-208,-208,-1000,-228,-1000,-208,-208,-208,-208,
-208,-1000,-1000,-208,-245,-1000,-1000,-1000,-1000,-1000,
-1000,-220,-1000,-270,-1000,-1000,-226,-1000,-1000,-228,
-208,-208,-250,-1000,-236,-1000,-1000,-208,-254,-208,
-239,-1000,-1000,-208,-262,-1000,-1000,-208,-1000 };
short Int_yypgo[]={

   0,  94,  93,  62,  92,  91,  90,  89,  88,  87,
  86,  85,  84,  83,  82,  81,  80,  57,  59,  78,
  77,  74,  73,  72,  71,  70,  69,  68,  66,  63,
  67,  61,  58 };
short Int_yyr1[]={

   0,   1,   1,   2,   2,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,
   5,   5,   6,  20,  21,   7,   8,  23,   9,  10,
  11,  16,  25,  26,  26,  27,  27,  12,  13,  14,
  14,  28,  29,  29,  15,  19,  19,  18,  18,  30,
  22,  22,  24,  24,  24,  31,  31,  31,  17,  17,
  32,  32 };
short Int_yyr2[]={

   0,   1,   0,   1,   2,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   2,   6,
   2,   1,   1,   0,   0,   8,   2,   0,   6,   1,
  10,   2,   2,   1,   4,   1,   3,   5,   7,   1,
   1,   2,   2,   1,   5,   1,   0,   1,   3,   3,
   3,   0,   1,   2,   3,   1,   1,   1,   1,   1,
   1,   1 };
short Int_yychk[]={

-1000,  -1,  -2,  -3,  -4,  -5,  -6,  -7,  -8,  -9,
 -10, -11, -12, -13, -14, -15, -16, 257, 258, 260,
 259, 283, 261, 262, 269, 284, -28, -29, 267, 273,
 288, 290,  -3, -17, 278, 263, 268, -17, -19, 291,
 -17, -22, 289, 270, 285, 286, 268, 274, 268, 285,
 -18, -30, -17, -17, -23, 277, -17, -17, -17, -17,
 279, 275, 277, 278, 278, -17, 271, 280, 280, 277,
 280, -30, -17, -20, -24, -31, -17, -32, 292, 265,
 266, -17, -17, -17, -17, -17, -18, 279, -31, 275,
 272, 281, -21, -31, -17, -17, 279, 278, -25, -26,
 -17, 279, -17, 278, -27, -17, 279, 275, -17 };
short Int_yydef[]={

   2,  -2,   1,   3,   5,   6,   7,   8,   9,  10,
  11,  12,  13,  14,  15,  16,  17,   0,  21,  22,
  46,   0,  51,  29,   0,   0,  39,  40,   0,   0,
   0,  43,   4,  18,   0,  58,  59,  20,   0,  45,
  26,  27,   0,   0,   0,   0,   0,  31,  41,  42,
   0,  47,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,  23,   0,  50,   0,   0,   0,   0,
   0,  48,  49,   0,   0,  52,  55,  56,  57,  60,
  61,   0,  37,   0,  44,  19,  24,  28,  53,   0,
   0,   0,   0,  54,   0,  38,  25,   0,   0,   0,
  33,  30,  32,   0,   0,  35,  34,   0,  36 };
#ifndef lint
static char yaccpar_sccsid[] = "@(#)yaccpar	4.1	(Berkeley)	2/11/83";
#endif

#
# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE Int_yyv[YYMAXDEPTH]; /* where the values are stored */
int Int_yychar = -1; /* current input token number */
int Int_yynerrs = 0;  /* number of errors */
short Int_yyerrflag = 0;  /* error recovery flag */

Int_yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	Int_yychar = -1;
	Int_yynerrs = 0;
	Int_yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &Int_yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, Int_yychar );
#endif
		if( ++yyps> &yys[YYMAXDEPTH] ) { Int_yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = Int_Int_yyval;

 yynewstate:

	yyn = Int_yypact[yystate];

	if( yyn<= YYFLAG ) goto Int_yydefault; /* simple state */

	if( Int_yychar<0 ) if( (Int_yychar=Int_yylex())<0 ) Int_yychar=0;
	if( (yyn += Int_yychar)<0 || yyn >= YYLAST ) goto Int_yydefault;

	if( Int_yychk[ yyn=Int_yyact[ yyn ] ] == Int_yychar ){ /* valid shift */
		Int_yychar = -1;
		Int_Int_yyval = Int_yylval;
		yystate = yyn;
		if( Int_yyerrflag > 0 ) --Int_yyerrflag;
		goto yystack;
		}

 Int_yydefault:
	/* default state action */

	if( (yyn=Int_yydef[yystate]) == -2 ) {
		if( Int_yychar<0 ) if( (Int_yychar=Int_yylex())<0 ) Int_yychar = 0;
		/* look through exception table */

		for( yyxi=Int_yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == Int_yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( Int_yyerrflag ){

		case 0:   /* brand new error */

			Int_yyerror( "syntax error" );
		yyerrlab:
			++Int_yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			Int_yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = Int_yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && Int_yychk[Int_yyact[yyn]] == YYERRCODE ){
			      yystate = Int_yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = Int_yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", Int_yychar );
#endif

			if( Int_yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			Int_yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= Int_yyr2[yyn];
		yypvt = yypv;
		yypv -= Int_yyr2[yyn];
		Int_Int_yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = Int_yyr1[yyn];
		yyj = Int_yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || Int_yychk[ yystate = Int_yyact[yyj] ] != -yyn ) yystate = Int_yyact[Int_yypgo[yyn]];
		switch(yym){
			
case 18:
# line 92 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		    DO_START;
		    boot_openrel(LexIDStr(yypvt[-0]));
		    DO_END; 
		} break;
case 19:
# line 98 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		    if (!Quiet) putchar('\n');
		    DO_START;
		    createrel(LexIDStr(yypvt[-0]));
		    DO_END;
		} break;
case 20:
# line 108 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		    DO_START;
		    closerel(LexIDStr(yypvt[-0]));
		    DO_END;
		} break;
case 21:
# line 114 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		    DO_START;
		    closerel(NULL);
		    DO_END;
		} break;
case 22:
# line 123 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		    DO_START;
		    printrel();
		    DO_END;
		} break;
case 23:
# line 132 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		    DO_START; 
		    numattr=(int)0;
		} break;
case 24:
# line 137 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		    if (!Quiet) putchar('\n');
		    DO_END;
		} break;
case 25:
# line 142 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		    DO_START; 
		    if (yypvt[-6]) {
			extern Relation reldesc;

			if (reldesc) {
			    puts("create bootstrap: Warning, open relation");
			    puts("exists, closing first");
			    closerel(NULL);
			}
			if (DebugMode)
			    puts("creating bootstrap relation");
			reldesc = heap_creatr(LexIDStr(yypvt[-5]),
					      numattr,
					      DEFAULT_SMGR,
					      attrtypes);
			if (DebugMode)
			    puts("bootstrap relation created ok");
		    } else {
			ObjectId id;
			extern ObjectId heap_create();

			id = heap_create(LexIDStr(yypvt[-5]),
					 'n',
					 numattr,
					 DEFAULT_SMGR,
					 attrtypes);
			if (!Quiet)
			    printf("CREATED relation %s with OID %d\n",
				   LexIDStr(yypvt[-5]), id);
		    }
		    DO_END;
		    if (DebugMode)
			puts("Commit End");
		} break;
case 26:
# line 181 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ DO_START; heap_destroy(LexIDStr(yypvt[-0])); DO_END;} break;
case 27:
# line 186 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		    DO_START;
		    if (DebugMode)
		        printf("tuple %d<", yypvt[-0]);
		    num_tuples_read = 0;
		} break;
case 28:
# line 193 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		    HeapTuple tuple;
		    if (num_tuples_read != numattr)
		        elog(WARN,"incorrect number of values for tuple");
		    if (reldesc == (Relation)NULL) {
		        elog(WARN,"must OPEN RELATION before INSERT\n");
		        err();
		    }
		    if (DebugMode)
			puts("Insert Begin");
		    objectid = yypvt[-4];
		    InsertOneTuple(objectid);
		    if (DebugMode)
			puts("Insert End");
		    if (!Quiet) { putchar('\n'); }
		    DO_END;
		    if (DebugMode)
			puts("Transaction End");
		} break;
case 29:
# line 216 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  StartTransactionCommand();
		  StartPortalAllocMode(DefaultAllocMode, 0);
		  cleanup();
		} break;
case 30:
# line 225 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  List params;

		  DO_START;

		  params = nappend1(LispNil, (List)yypvt[-1]);
		  defineindex(LexIDStr(yypvt[-5]), 
			      LexIDStr(yypvt[-7]), 
			      LexIDStr(yypvt[-3]),
			      params);
		  DO_END;
		} break;
case 31:
# line 240 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ build_indices(); } break;
case 32:
# line 244 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  Int_Int_yyval = (YYSTYPE)nappend1(LispNil, (List)yypvt[-1]);
		  nappend1((List)Int_Int_yyval, lispString(LexIDStr(yypvt[-0])));
		} break;
case 33:
# line 251 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  Int_Int_yyval = (YYSTYPE)lispString(LexIDStr(yypvt[-0]));
		} break;
case 34:
# line 255 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  Int_Int_yyval = (YYSTYPE)nappend1(LispNil, lispString(LexIDStr(yypvt[-3])));
		  rplacd((List)Int_Int_yyval, (List)yypvt[-1]);
		} break;
case 35:
# line 262 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  Int_Int_yyval = (YYSTYPE)nappend1(LispNil, lispString(LexIDStr(yypvt[-0])));
		} break;
case 36:
# line 266 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  Int_Int_yyval = (YYSTYPE)nappend1((List)yypvt[-2], lispString(LexIDStr(yypvt[-0])));
		} break;
case 37:
# line 272 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		    DO_START;
		    renamerel(LexIDStr(yypvt[-2]), LexIDStr(yypvt[-0]));
		    DO_END;
		} break;
case 38:
# line 281 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ DO_START;
		  renameatt(LexIDStr(yypvt[-0]), LexIDStr(yypvt[-4]), LexIDStr(yypvt[-2]));
		  DO_END;
		} break;
case 41:
# line 294 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		  DO_START;
		  printmacros(); 
		  DO_END;
		} break;
case 42:
# line 303 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  DO_START;
		  boot_openrel(RelationRelationName->data);
		  printrel();
		  closerel(RelationRelationName->data);
		  DO_END;
		} break;
case 43:
# line 311 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{
		  DO_START;
		  printrel();
		  DO_END;
		} break;
case 44:
# line 320 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ /* for now, simple subst only */
		  DO_START;
		  DefineMacro(yypvt[-2],yypvt[-0]);
		  DO_END;
		} break;
case 45:
# line 328 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval = 1; } break;
case 46:
# line 329 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval = 0; } break;
case 49:
# line 339 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ 
		   char name[16],type[16];
		   if(++numattr > MAXATTR)
			elog(FATAL,"Too many attributes\n");
		   DefineAttr(LexIDStr(yypvt[-2]),LexIDStr(yypvt[-0]),numattr-1);
		   if (DebugMode)
		       printf("\n");
		} break;
case 50:
# line 350 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval = atol(LexIDStr(yypvt[-0])); 		} break;
case 51:
# line 351 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ extern OID newoid(); Int_Int_yyval = newoid();	} break;
case 55:
# line 361 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ InsertOneValue(objectid, LexIDStr(yypvt[-0]), num_tuples_read++); } break;
case 56:
# line 362 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ InsertOneValue(objectid, LexIDStr(yypvt[-0]), num_tuples_read++); } break;
case 57:
# line 364 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ InsertOneNull(num_tuples_read++); } break;
case 58:
# line 368 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval=Int_yylval; } break;
case 59:
# line 369 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval=Int_yylval; } break;
case 60:
# line 373 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval=Int_yylval; } break;
case 61:
# line 374 "/usr/local/src/postgres/src/backend/bootstrap/bootparse.y"
{ Int_Int_yyval=Int_yylval; } break; 
		}
		goto yystack;  /* stack new state and value */

	}
