/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	gdi_f77_dbobj.c
 *
 * SYNOPSIS
 *
 *	#include "libgdi.h"
 *
 *
 * DESCRIPTION
 *
 *	This file contains functions for accessing the dbObj of the
 *	Generic Database Interface.
 *
 * DIAGNOSTICS
 *
 *	Functions which return pointers will return NULL if an error
 *	occurred.  Functions which return a non-negative int will return 
 *	-1 if an error occurred.
 *
 * FILES
 *
 *	gdi_f77_dbobj.c (this file)
 *
 * NOTES
 *       dbobj access from FORTRAN currently not supported.
 *
 * SEE ALSO
 *
 *	libgdi.h
 *
 * AUTHOR
 */

#include <stdio.h>
#include "libgdi.h"
#include "f77defs.h"

#ifndef	lint
static char SccsId[] = "@(#)gdi_f77_dbobj.c	16.2 8/11/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif



dbObj *
gdi_obj_create_ (constr)
dbConstr	*constr;
{
	return ((dbObj *)NULL);
}


dbObj*
gdi_obj_destroy_ (obj)
dbObj	*obj;
{
	return ((dbObj *)NULL);
}

