/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	pg_abort()	- Bogus function for GDI compatibility
 *
 * DESCRIPTION
 *	I don't think there is a way to abort a query in POSTGRES, but this
 *	function is here for GDI compatibility.
 *
 * FILES
 *	pg_abort.c (this file)
 *
 * AUTHOR
 *	Jean Anderson
 */
#ifndef	lint
static char SccsId[] = "@(#)pg_abort.c	16.1 8/3/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif

#include "gdi_postgres.h"

dbStatus
pg_abort (conn)
dbConn		*conn;
{
	if(GDI_ERROR_DEBUG(conn) == GDI_DEBUG_VERBOSE)
		fprintf(stderr,
		"pg_abort: function not applicable to this database.\n");
	return (GDI_SUCCESS);
}
