.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" $Header: /data/01/postgres/src/ref/RCS/tmac.an.nr,v 1.1 1993/01/26 02:43:13 aoki Exp $
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.1
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/remove_function.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" $Header: /data/01/postgres/src/ref/postquel/RCS/remove_function.cmdsrc,v 1.7 1993/05/24 23:52:29 avi Exp $
.TH "REMOVE FUNCTION" COMMANDS 01/23/93
.XA 2 "Remove Function"
.SH NAME
remove function \(em remove a user-defined C function 
.SH SYNOPSIS
.(l M
\fBremove function ( \fP[ type-1  { \fB,\fP type-n } ] \fB) \fR function_name
.)l
.SH DESCRIPTION
.BR "Remove function"
will remove references to an existing C function.  To execute this
command the user must be the owner of the function.  The input
argument types to the function must be specified, as only the
function with the given name and argument types will be romoved.
.SH EXAMPLE
.(C
/*
 * this command removes the square root function
 */
remove function sqrt
.)C
.SH "SEE ALSO"
define function(commands).
.SH BUGS
No support is currently provided for removing \*(PQ functions.
.PP
No checks are made to ensure that types, operators or access methods
that rely on the function have been removed first.
