#!/local/bin/tcl
# This script will create a directory hierarchy similar to 
# the postgres large_objects,  it creates a directory called
# pG_temp in the users current directory, Icopy blows it away
# at the end.
# the main time sync is how long a pls -R takes.

	if [file exists pG_temp] {
		rm -rf pG_temp
	}
	exec mkdir pG_temp
	exec pls -D sequoia -H heel.s2k.berkeley.edu -R > pg_temp.files
	set dir .
        set file pg_temp.files
        if [catch {set fd [open $file r]} err] {
                exit 1
        }

        while { ![eof $fd] } {
                set line [gets $fd]
# I couldn't figure out now to match the *: in the case statement			
		set outcome [string first : $line ]
		if  {$outcome != -1} { 
			set dir [string trimright $line :]
			exec rm -f pG_temp/$dir
			exec mkdir pG_temp/$dir
		} else {
                case $line in {
                        "^$"  {}
                        default {
				set newfile [string trimright $line /]
				if ![file exists pG_temp/$dir/$newfile] {
					exec touch -f pG_temp/$dir/$newfile
				}

                       }
                }
		}
        }
        close $fd
	exec rm -f pg_temp.files

